/***********************************************************************/
/*                                                                     */
/*  FILE        :Analog_drv.c                                          */
/*  DATE        :Wed, Sep 03, 2009                                     */
/*  DESCRIPTION :Analog Function		                               */
/*  CPU TYPE    :H8SX/1653                                             */
/*                                                                     */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include "Analog_Drv.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void Analog_Initalize(void);
#ifdef __cplusplus
}
#endif

//w~b҂
void WaitTime(int time)
{
	while( time -- > 0 )
	{
	
		// 100usec𐳊mɒ~
		// 
		__asm{
									// 48MHz Clock    = 0.02083usec
									// Apart 16clock  * 0.02083usec       =  0.3333 usec 
									// Bpart  8clock  * 0.02083usec * 598 = 99.6666 usec
									// Total                                99.9999 usec

									// Clock
			push.w		r0			// 6 A
			mov.w		#598,r0		// 4 A
		waitLoop:					
			dec.w		#1,r0		// 2 B
			and.w		r0,r0		// 2 B
			bne			waitLoop	// 4 B
			pop.w		r0			// 6 A
		}
	}
}


//AiOH̏
void Analog_Initalize(void)
{
	//DAAADW[𓮍삳B
	MSTP.CRA.BIT._DA 	= 0;	//ԂDAW[͒~ĂB
	MSTP.CRA.BIT._AD 	= 0;	//ԂADW[͒~ĂB
	
	
	//DA|[g^ɁAnCCs[^XԂ0VɂB
	DA.DADR0  			= 0;	// Vce.out=0V
	DA.DADR1  			= 0;	// Ib=0V
	DA.DACR01.BIT.DAOE1	= 1;	// DA1o
	DA.DACR01.BIT.DAOE0	= 1;	// DA0o
	DA.DACR01.BIT.DAE	= 1;	// `lOCPDAϊ
	

	//AD|[g̓͂~B
	AD.ADCSR.BIT.ADF	= 0;	// A/DGhtO
	AD.ADCSR.BIT.ADIE	= 0;	// ADI荞݂֎~
	AD.ADCSR.BIT.ADST	= 0;	// A/Dϊ~
	AD.ADCSR.BIT.CH		= 1;	// AN0,AN1AiO͂B
	AD.ADCR.BIT.TRGS	= 0;	// OgK[B
	AD.ADCR.BIT.SCANE	= 1;	// XL[h
	AD.ADCR.BIT.SCANS	= 0;	// 4`l
	AD.ADCR.BIT.CKS		= 0;	// Œxϊ=68Xe[g 	
}

//AiOḦA̓
//vIbDA1,vVceInDA0Ɋ|A
//vWait[ms]҂āA
//vICAD1,vVceOutAD0͂B
void Analog_Proc( int vIb, int vVceIn,int vWait,int vFlag, int * vIc,int * vVceOut )
{
	//DȀo͂ݒ肷B
	DA.DADR0 = vVceIn;
	DA.DADR1 = vIb;
	
	WaitTime( vWait );		// w莞Ԓ~BimSecP)
	
	//AD̓͂JnB
	AD.ADCSR.BIT.ADF  = 0;	// A/DϊItOZbg
	AD.ADCSR.BIT.ADST = 1;	// A/DϊJn
	while( AD.ADCSR.BIT.ADF == 0 );	// A/DϊI҂ [vӁI
	AD.ADCSR.BIT.ADST = 0;	// A/DϊI
	
	*vVceOut = AD.ADDRA >> 6;	// AD0̓ǂݍ(16bit10bitɒli[ĂBj
	*vIc     = AD.ADDRB >> 6;	// AD1̓ǂݍ(16bit10bitɒli[ĂBj
	
	//FlagBit0ONł΁AʓdԂێBiLu[Vׁ̈j
	if(( vFlag & 0x01) == 0)
	{
		//vIDȀo͂0ɂB
		//Hi-Zׂɂďo͋֎~ɂ͂ȂB
		DA.DADR0 = 0;
		DA.DADR1 = 0;
	}
}
